docker-build:
  # Use the official docker image.
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  # Default branch leaves tag empty (= latest tag)
  # All other branches are tagged with the escaped branch name (commit ref slug)
  script:
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        tag=""
        echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
      else
        tag=":$CI_COMMIT_REF_SLUG$CI_JOB_ID"
        echo "Running on branch '$CI_COMMIT_BRANCH': tag = ${tag}${CI_JOB_ID}"
      fi
    - docker build --pull -t "$CI_REGISTRY_IMAGE${tag}" .
    - docker push "$CI_REGISTRY_IMAGE${tag}"
    - echo "IMAGE_NAME=$CI_REGISTRY_IMAGE${tag}" >> build.env
  # Run this job in a branch where a Dockerfile exists
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - Dockerfile
  artifacts:
    reports:
      dotenv: build.env

deploy:
  # Use the official docker image.
  image: warching/kustomize
  stage: deploy
  variables:
    PAT_TOKEN: $PAT_TOKEN
    K8S_PATH: game/ptcg/overlays/dev
    ORIGINAL_IMAGE: warching/ptcg-socket
  script:
    - |
      echo "$IMAGE_NAME"
      git config --global user.email "${GITLAB_USER_EMAIL}"
      git config --global user.name "${GITLAB_USER_NAME}"
      git clone https://oauth2:${PAT_TOKEN}@gitlab.com/boardgamehk/kubernetes.git
      cd kubernetes/${K8S_PATH}
      kustomize edit set image ${ORIGINAL_IMAGE}=${IMAGE_NAME}
      git add .
      git commit -m "${CI_PROJECT_NAME} ${CI_COMMIT_REF_NAME} update image tag"
      git push origin main
  dependencies:
    - docker-build
